﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace ErrorTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        DataTable dt;
        private void btnLoad_Click(object sender, EventArgs e)
        {
            dt = new DataTable();
            dt.Columns.Add("Name", typeof(string));
            dt.Columns.Add("Address", typeof(string));

            DataRow dr;

            for (int i = 1; i < 5; i++)
            {
                dr = dt.NewRow();
                dr["Name"] = "Name " + i.ToString();
                dr["Address"] = "Address " + i.ToString();
                dt.Rows.Add(dr);
            }
            ultraGrid1.DataSource = dt;
        }

      
        private void button1_Click(object sender, EventArgs e)
        {
            if ((dt.Rows != null) && (dt.Rows.Count > 0))
                foreach (DataRow dr in dt.Rows)
                {
                    dr.ClearErrors();
                    if (string.IsNullOrEmpty(dr["Name"].ToString()))
                    {
                        dr.SetColumnError("Name", "Name is required.");
                        dr.RowError = "Error";
                    }
                    if (string.IsNullOrEmpty(dr["Address"].ToString()))
                    {
                        dr.SetColumnError("Address", "Address is required.");
                        dr.RowError = "Error";
                    }
                }

            ultraGrid1.Refresh();
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.SupportDataErrorInfo = SupportDataErrorInfo.RowsAndCells;
            e.Layout.Override.RowSelectors = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.RowSelectorWidth = 32;
            e.Layout.Override.DataErrorCellAppearance.ForeColor = Color.Red;
            e.Layout.Override.DataErrorRowAppearance.BackColor = Color.LightYellow;
            e.Layout.Override.DataErrorRowSelectorAppearance.BackColor = Color.Green;
            e.Layout.ScrollStyle = ScrollStyle.Immediate;
        }
    }
}
